---

stages:
  - lint
  - test
  - build
  - deploy
image: gitlab-registry.oit.duke.edu/oit-ssi-systems/docker-helm-packager:v1-0-2

variables:
  VAULT_ADDR: https://vault-systems.oit.duke.edu

default:
  tags:
    - oit-shared


lint:
  stage: lint
  script: helm lint

Build Package:
  stage: build
  only:
    - main
  script:
    - mkdir package/
    - helm package . --destination package/
  artifacts:
    paths:
      - package/

Push to Chartmuseum:
  stage: deploy
  only:
    - main
  script:
    - |
      set -e
      export VAULT_TOKEN="$(vault write -field=token auth/gitlab/login \
                          role=helm-uploader jwt=$CI_JOB_JWT)"
      export CHARTS_REPO="$(vault read -field=url secret/helm/harbor-charts)"
      export CHARTS_USER="$(vault read -field=username \
                          secret/helm/harbor-charts)"
      export CHARTS_PASSWORD="$(vault read -field=password \
                              secret/helm/harbor-charts)"
    - |
      helm repo add ssi-systems ${CHARTS_REPO}
      ls -latr package/*.tgz
      helm push package/*.tgz ssi-systems \
        -u "${CHARTS_USER}" -p "${CHARTS_PASSWORD}"
  artifacts:
    paths:
      - package/
